scriptname _DE_CampFireKit_PlacedUnlit_ACT_Man extends ObjectReference

import utility

keyword property _DE_BlockOnKeyword auto
keyword property _DE_BlockOffKeyword auto

spell property Flames auto
spell property Firebolt auto
spell property Fireball auto
spell property Incinerate auto
spell property WallofFlames auto
spell property FireStorm auto
spell property VoiceFireBreath1 auto
spell property VoiceFireBreath2 auto
spell property VoiceFireBreath3 auto
GlobalVariable property _DE_BlockState auto
message property _DE_CampFireKit_PlacedManual_ACT_Menu auto
activator property _DE_CampFireKit_Placed_ACT auto
float property pCreateTime auto
furniture property CraftingCookingPotSm auto
static property _DE_CookRack auto
MiscObject property _DE_CampCookingPot_MISC auto
bool property bEventLock = false auto


Event OnInit()
	pCreateTime = GetCurrentGameTime()
	RegisterForSingleUpdate(2)
endEvent

Event OnUpdate()
	if GetCurrentGameTime() - pCreateTime > 2.0 					;After 48 hours, destroy this campfire
		FireKit_Placed_Destroy_LeavePot()
	endif
		
	if _DE_BlockState.GetValueInt() == 2
		if Game.GetPlayer().GetEquippedItemType(0) == 11 || Game.GetPlayer().GetEquippedItemType(1) == 11		;Player has torch equipped
			;debug.notification("I'm blocking with a torch")
			if self.GetDistance(Game.GetPlayer()) < 130
				StartFire()
			endif
		endif
	endif
		
	RegisterForSingleUpdate(2)
	
endEvent

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	if akSource == Flames || akSource == Firebolt || akSource == Fireball || akSource == Incinerate || akSource == WallOfFlames || akSource == FireStorm || akSource == VoiceFireBreath1 || akSource == VoiceFireBreath2 || akSource == VoiceFireBreath3
		if bEventLock == false
			StartFire()
		endif
	endif
endEvent

Event OnActivate(ObjectReference akActionRef)
	int ibutton = _DE_CampFireKit_PlacedManual_ACT_Menu.Show()
	if ibutton == 0
		FireKit_Placed_Destroy()
	else
		;exit
	endif
endEvent

function StartFire()
	bEventLock = true
	self.PlaceAtMe(_DE_CampFireKit_Placed_ACT)
	;Remove unlit fire
	wait(2)										;Make sure the new fire has appeared
	FireKit_Placed_Destroy_LeavePot()
endFunction	

function FireKit_Placed_Destroy_LeavePot()
    self.disable(false)
	self.Delete()
endFunction

function FireKit_Placed_Destroy()
	ObjectReference mycookingpot = Game.FindClosestReferenceOfTypeFromRef(CraftingCookingPotSm, self, 100.0)
	if mycookingpot != None
		mycookingpot.disable()
		mycookingpot.delete()
		Game.GetPlayer().AddItem(_DE_CampCookingPot_MISC)
	endif
	ObjectReference myrack = Game.FindClosestReferenceOfTypeFromRef(_DE_CookRack, self, 100.0)
	if myrack != None
		myrack.disable()
		myrack.delete()
	endif
	UnregisterForUpdate()
    self.disable(false)
	self.Delete()
endfunction