Scriptname _DE_FireKit_Packed_ACT_Script extends ObjectReference 
{Script that drives the droppable Fire Kit item for player activation.}

import Message

Message property _DE_CampFireKit_MISC_Menu auto
{Reference to the Camp Fire Kit Menu.}
Activator property _DE_CampFireKit_Placed_ACT auto
{Reference to the Campfire Activator}
MiscObject property _DE_CampFireKit_MISC auto
{Reference to the Misc Item (Droppable Inventory) Fire Kit}
Activator property _DE_CampFireKit_Packed_ACT auto
{Reference to the packed Activator Fire Kit.}
Activator property _DE_CampFireKit_PlacedUnlit_ACTmanual auto
GlobalVariable property _DE_Setting_Lighting auto
float property myXOffset auto
float property myYOffset auto

Event OnInit()
	self.SetAngle(0.0, 0.0, 0.0)
	GetOffset()
	self.MoveTo(self, myXOffset, myYOffset, 0.0)
	utility.wait(0.5)
	self.ApplyHavokImpulse(0.0, 0.0, -1.0, 1.0)		;Force to fall to the ground, like an item drop
endEvent

Event OnActivate(ObjectReference akActionRef)
        
    int iButton = _DE_CampFireKit_MISC_Menu.Show()
   
    int iFuncReturn = -1
   
    if iButton == 0
        FireKit_LightFire()
    elseif iButton == 1
        FireKit_PickUp()
	endif
endEvent

function FireKit_LightFire()
    ;Create the campfire at this position
	if _DE_Setting_Lighting.GetValueInt() == 2
		self.PlaceAtMe(_DE_CampFireKit_PlacedUnlit_ACTmanual)
	else
		self.PlaceAtMe(_DE_CampFireKit_Placed_ACT)
	endif
    self.Disable(true)
	self.Delete()
endfunction   
        
function FireKit_PickUp()
    ;Pick it up
	Game.GetPlayer().AddItem(_DE_CampFireKit_MISC)
	self.Disable(false)
	self.Delete()
endfunction

function GetOffset()
	;Trigonometry time! We need to position the campsite item such that it is dropped in front of the player.
	int myQuad = 1
	float mySideC = 100.0	;Hypotenuse (distance to move the object forward)
	float myAngleA = (Game.GetPlayer().GetAngleZ() + 30.0)
	
	float myAngleC = 90.0
	
	;Clamp to an angle less than 90 degrees.
	if myAngleA > 90.0 && myAngleA <= 180.0
		myAngleA -= 90.0
		myQuad = 2
	elseif myAngleA > 180.0 && myAngleA <= 270.0
		myAngleA -= 180.0
		myQuad = 3
	elseif myAngleA > 270.0
		myAngleA -= 270.0
		myQuad = 4
	endif
	
	float mySideA
	float mySideB
	
	;Determine the length of the legs of the triangle for moving the player.
	if myQuad == 1 || myQuad == 3
		mySideA = math.sin(myAngleA) * mySideC				;Y offset
		mySideB = math.cos(myAngleA) * mySideC				;X offset
	else
		mySideA = math.cos(myAngleA) * mySideC				;Y offset
		mySideB = math.sin(myAngleA) * mySideC				;X offset
	endif
	
	;Figure out which direction the offset should travel based on the quadrant.
		
	if myQuad == 1
		;Move farther into the 1st quadrant
		myXOffset = mySideA
		myYOffset = mySideB
	elseif myQuad == 2
		;Move farther into the 2nd quadrant
		myXOffset = mySideA
		myYOffset = mySideB * -1.0
	elseif myQuad == 3
		;Move farther into the 3rd quadrant
		myXOffset = mySideA * -1.0
		myYOffset = mySideB * -1.0
	elseif myQuad == 4
		;Move farther into the 4th quadrant
		myXOffset = mySideA * -1.0
		myYOffset = mySideB
	endif

endFunction
