Scriptname _DE_FireKit_Placed_ACT_Script extends ObjectReference
{Script that drives the lit Fire Kit.  Allows you to break down the campfire.}

import Message
import utility
Message property _DE_CampFireKit_Placed_ACT_Menu auto
{Reference to the Camp Fire Kit Menu.}
GlobalVariable property _DE_Count_FireKit auto
GlobalVariable property _DE_Count_CookingPot auto
furniture property CraftingCookingPotSm auto
static property _DE_CookRack auto
Light property LightCampFire01 auto
ObjectReference property myLight auto
float property pCreateTime auto
Activator property _DE_FireKit_PlacedUnlit_ACT auto
MiscObject property _DE_CampCookingPot_MISC auto
bool property bEventLock auto


Event OnInit()
	self.SetAngle(0.0, 0.0, 0.0)
	;self.MoveTo(self, 0.0, 0.0, -10.0)
	myLight = self.PlaceAtMe(LightCampFire01)
	myLight.MoveTo(Self, 0.0, 0.0, 5.0)
	pCreateTime = GetCurrentGameTime()
	RegisterForSingleUpdate(1)
endEvent

Event OnUpdate()
	if bEventLock == false
		bEventLock = true
		if GetCurrentGameTime() - pCreateTime >= 0.25				;Fire goes out after 6 hours
			self.PlaceAtMe(_DE_FireKit_PlacedUnlit_ACT)
			wait(1)
			FireKit_Placed_Destroy_LeavePot()
		else
			RegisterForSingleUpdate(1)
		endif
	endif
	bEventLock = false
endEvent

Event OnActivate(ObjectReference akActionRef)
       
    int iButton = _DE_CampFireKit_Placed_ACT_Menu.Show()
  
    ;What do you want to do?
    ;1: Destroy Campfire 2: Cancel
  
    if iButton == 0
        FireKit_Placed_Destroy()
    elseif iButton == 1
        ;do nothing
    endif
endEvent

function FireKit_Placed_Destroy_LeavePot()
	UnregisterForUpdate()
	myLight.disable()
	myLight.Delete()
    self.disable(false)
	self.Delete()
endFunction

function FireKit_Placed_Destroy()
	ObjectReference mycookingpot = Game.FindClosestReferenceOfTypeFromRef(CraftingCookingPotSm, self, 100.0)
	if mycookingpot != None
		mycookingpot.disable()
		mycookingpot.delete()
		Game.GetPlayer().AddItem(_DE_CampCookingPot_MISC)
	endif
	ObjectReference myrack = Game.FindClosestReferenceOfTypeFromRef(_DE_CookRack, self, 100.0)
	if myrack != None
		myrack.disable()
		myrack.delete()
	endif
	UnregisterForUpdate()
	myLight.disable()
	myLight.Delete()
    self.disable(false)
	self.Delete()
endfunction