Scriptname _DE_FireKit_PlacedUnlit_ACT_Script extends ObjectReference
{Script that drives the lit Fire Kit.  Allows you to break down the campfire.}

import Message
import utility
Message property _DE_CampFireKit_PlacedUnlit_ACT_Menu auto
{Reference to the Camp Fire Kit Menu.}
Message property _DE_CampFireKit_Placed_Rekindle auto
Message property _DE_CampFireKit_Placed_RekindleError auto
MiscObject property Firewood01 auto
furniture property CraftingCookingPotSm auto
static property _DE_CookRack auto
Light property LightCampFire01 auto
ObjectReference property myLight auto
Activator property _DE_FireKit_Placed_ACT auto
Activator property _DE_CampFireKit_PlacedUnlit_ACTmanual auto
GlobalVariable property _DE_Setting_Lighting auto
float property pCreateTime auto
MiscObject property _DE_CampCookingPot_MISC auto

Event OnInit()
	self.SetAngle(0.0, 0.0, 0.0)
	;self.MoveTo(self, 0.0, 0.0, -10.0)
	pCreateTime = GetCurrentGameTime()
	RegisterForUpdate(1)
endEvent

Event OnUpdate()
	if GetCurrentGameTime() - pCreateTime > 1.75 					;After 42 hours (6 lit + 42 unlit = 48 hours), destroy this campfire
		FireKit_Placed_Destroy()
	endif
endEvent

Event OnActivate(ObjectReference akActionRef)
       
    int iButton = _DE_CampFireKit_PlacedUnlit_ACT_Menu.Show()
  
    ;What do you want to do?
    ;1: Rekindle Campfire 2: Destroy Campfire 3: Cancel
  
    if iButton == 0
		FireKit_Placed_Rekindle()
	elseif iButton == 1
        FireKit_Placed_Destroy()
    elseif iButton == 1
        ;do nothing
    endif
endEvent

function FireKit_Placed_Rekindle()
	if _DE_Setting_Lighting.GetValueInt() == 2
		if Game.GetPlayer().GetItemCount(Firewood01) >= 2
			Game.GetPlayer().RemoveItem(Firewood01, 2)
			self.PlaceAtMe(_DE_CampFireKit_PlacedUnlit_ACTmanual)
			FireKit_Placed_Destroy_LeavePot()
		else
			_DE_CampFireKit_Placed_RekindleError.Show()
			_DE_CampFireKit_PlacedUnlit_ACT_Menu.Show()
		endif
	else
		if Game.GetPlayer().GetItemCount(Firewood01) >= 2
			_DE_CampFireKit_Placed_Rekindle.Show()
			Game.GetPlayer().RemoveItem(Firewood01, 2)
			self.PlaceAtMe(_DE_FireKit_Placed_ACT)
			;Remove unlit fire
			FireKit_Placed_Destroy_LeavePot()
		else
			_DE_CampFireKit_Placed_RekindleError.Show()
			_DE_CampFireKit_PlacedUnlit_ACT_Menu.Show()
		endif
	endif	
endFunction

function FireKit_Placed_Destroy_LeavePot()
	UnregisterForUpdate()
    self.disable(false)
	self.Delete()
endFunction

function FireKit_Placed_Destroy()
	ObjectReference mycookingpot = Game.FindClosestReferenceOfTypeFromRef(CraftingCookingPotSm, self, 100.0)
	if mycookingpot != None
		mycookingpot.disable()
		mycookingpot.delete()
		Game.GetPlayer().AddItem(_DE_CampCookingPot_MISC)
	endif
	ObjectReference myrack = Game.FindClosestReferenceOfTypeFromRef(_DE_CookRack, self, 100.0)
	if myrack != None
		myrack.disable()
		myrack.delete()
	endif
	UnregisterForUpdate()
    self.disable(false)
	self.Delete()
endfunction