Scriptname _DE_Tent_Packed_ACT_Multi extends ObjectReference
{Script that drives the droppable Tent item for player activation.}

import Message
import debug

MiscObject property _DE_CampTentHide_MISC_10 auto
MiscObject property _DE_CampTentHide_MISC_9 auto
MiscObject property _DE_CampTentHide_MISC_8 auto
MiscObject property _DE_CampTentHide_MISC_7 auto
MiscObject property _DE_CampTentHide_MISC_6 auto
MiscObject property _DE_CampTentHide_MISC_5 auto
MiscObject property _DE_CampTentHide_MISC_4 auto
MiscObject property _DE_CampTentHide_MISC_3 auto
MiscObject property _DE_CampTentHide_MISC_2 auto
MiscObject property _DE_CampTentHide_MISC_1 auto

Activator property _DE_CampTent_Packed_ACT_10 auto
Activator property _DE_CampTent_Packed_ACT_9 auto
Activator property _DE_CampTent_Packed_ACT_8 auto
Activator property _DE_CampTent_Packed_ACT_7 auto
Activator property _DE_CampTent_Packed_ACT_6 auto
Activator property _DE_CampTent_Packed_ACT_5 auto
Activator property _DE_CampTent_Packed_ACT_4 auto
Activator property _DE_CampTent_Packed_ACT_3 auto
Activator property _DE_CampTent_Packed_ACT_2 auto
Activator property _DE_CampTent_Packed_ACT_1 auto
Activator property _DE_CampTent_Placed_ACT_10 auto
Activator property _DE_CampTent_Placed_ACT_9 auto
Activator property _DE_CampTent_Placed_ACT_8 auto
Activator property _DE_CampTent_Placed_ACT_7 auto
Activator property _DE_CampTent_Placed_ACT_6 auto
Activator property _DE_CampTent_Placed_ACT_5 auto
Activator property _DE_CampTent_Placed_ACT_4 auto
Activator property _DE_CampTent_Placed_ACT_3 auto
Activator property _DE_CampTent_Placed_ACT_2 auto
Activator property _DE_CampTent_Placed_ACT_1 auto

Message property _DE_CampTent_MISC_Menu auto
{Reference to the Camp Tent Menu.}

float property myXOffset auto
float property myYOffset auto

Event OnInit()
	;Game.DisablePlayerControls()					;Force the player out of their inventory
	;Game.EnablePlayerCOntrols()
	self.SetScale(2.0)								;Test
	self.SetAngle(0.0, 0.0, 0.0)					;Needs work
	GetOffset()
	self.MoveTo(self, myXOffset, myYOffset, 20.0)
	utility.wait(0.5)
	self.ApplyHavokImpulse(0.0, 0.0, -1.0, 1.0)		;Force to fall to the ground, like an item drop
endEvent

Event OnActivate(ObjectReference akActionRef)
       
    int iButton = _DE_CampTent_MISC_Menu.Show()
  
    int iFuncReturn = -1
  
    if iButton == 0
        Tent_Pitch()
    elseif iButton == 1
        Tent_PickUp()
    elseif iButton == 2
        ;do nothing
    endif
endEvent

function Tent_Pitch()
    ;Create the tent at this position
	if self.GetBaseObject() == _DE_CampTent_Packed_ACT_10
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_10)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_9
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_9)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_8
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_8)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_7
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_7)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_6
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_6)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_5
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_5)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_4
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_4)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_3
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_3)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_2
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_2)
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_1
		self.PlaceAtMe(_DE_CampTent_Placed_ACT_1)
	endif
	
    self.Disable(true)
	self.Delete()
endfunction  
       
function Tent_PickUp()
    ;Pick it up
    if self.GetBaseObject() == _DE_CampTent_Packed_ACT_10
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_10)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_9
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_9)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_8
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_8)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_7
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_7)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_6
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_6)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_5
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_5)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_4
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_4)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_3
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_3)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_2
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_2)
		self.Disable()
		self.Delete()
	elseif self.GetBaseObject() == _DE_CampTent_Packed_ACT_1
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_1)
		self.Disable()
		self.Delete()
	endif
endfunction

function GetOffset()
	;Trigonometry time! We need to position the campsite item such that it is dropped in front of the player.
	int myQuad = 1
	float mySideC = 100.0	;Hypotenuse (distance to move the object forward)
	float myAngleA = Game.GetPlayer().GetAngleZ()
	
	float myAngleC = 90.0
	
	;Clamp to an angle less than 90 degrees.
	if myAngleA > 90.0 && myAngleA <= 180.0
		myAngleA -= 90.0
		myQuad = 2
	elseif myAngleA > 180.0 && myAngleA <= 270.0
		myAngleA -= 180.0
		myQuad = 3
	elseif myAngleA > 270.0
		myAngleA -= 270.0
		myQuad = 4
	endif
	
	float mySideA
	float mySideB
	
	;Determine the length of the legs of the triangle for moving the player.
	if myQuad == 1 || myQuad == 3
		mySideA = math.sin(myAngleA) * mySideC				;Y offset
		mySideB = math.cos(myAngleA) * mySideC				;X offset
	else
		mySideA = math.cos(myAngleA) * mySideC				;Y offset
		mySideB = math.sin(myAngleA) * mySideC				;X offset
	endif
	
	;Figure out which direction the offset should travel based on the quadrant.
		
	if myQuad == 1
		;Move farther into the 1st quadrant
		myXOffset = mySideA
		myYOffset = mySideB
	elseif myQuad == 2
		;Move farther into the 2nd quadrant
		myXOffset = mySideA
		myYOffset = mySideB * -1.0
	elseif myQuad == 3
		;Move farther into the 3rd quadrant
		myXOffset = mySideA * -1.0
		myYOffset = mySideB * -1.0
	elseif myQuad == 4
		;Move farther into the 4th quadrant
		myXOffset = mySideA * -1.0
		myYOffset = mySideB
	endif

endFunction
