Scriptname _DE_Tent_Placed_ACT_Multi extends ObjectReference
{Script that drives the pitched tent.  Allows you to break down the tent.}

import Message
import debug
import utility

MiscObject property _DE_CampTentHide_MISC_10 auto
MiscObject property _DE_CampTentHide_MISC_9 auto
MiscObject property _DE_CampTentHide_MISC_8 auto
MiscObject property _DE_CampTentHide_MISC_7 auto
MiscObject property _DE_CampTentHide_MISC_6 auto
MiscObject property _DE_CampTentHide_MISC_5 auto
MiscObject property _DE_CampTentHide_MISC_4 auto
MiscObject property _DE_CampTentHide_MISC_3 auto
MiscObject property _DE_CampTentHide_MISC_2 auto
MiscObject property _DE_CampTentHide_MISC_1 auto
MiscObject property _DE_CampTentHide_MISC_0 auto

Activator property _DE_CampTent_Placed_ACT_10 auto
Activator property _DE_CampTent_Placed_ACT_9 auto
Activator property _DE_CampTent_Placed_ACT_8 auto
Activator property _DE_CampTent_Placed_ACT_7 auto
Activator property _DE_CampTent_Placed_ACT_6 auto
Activator property _DE_CampTent_Placed_ACT_5 auto
Activator property _DE_CampTent_Placed_ACT_4 auto
Activator property _DE_CampTent_Placed_ACT_3 auto
Activator property _DE_CampTent_Placed_ACT_2 auto
Activator property _DE_CampTent_Placed_ACT_1 auto
Message property _DE_CampTent_Placed_ACT_Menu auto
{Reference to the Camp Tent Menu.}
message property _DE_Backpack_MISC_Error_Tent_FallApart auto
Message property _DE_Backpack_MISC_Success_Tent auto
Message property _DE_Backpack_MISC_Error_Tent_TooMany auto
GlobalVariable property _DE_Count_Tent auto
GlobalVariable property _DE_Setting_Tent auto
GlobalVariable property _DE_CurrentTemp auto
ObjectReference property myBed auto
ObjectReference property SnowTent auto
Static property NorTentSmallSnow auto
Furniture property Bedroll01 auto
float property pCreateTime auto
bool property pSnowTentCreated auto

Event OnInit()
	self.SetAngle(0.0, 0.0, Game.GetPlayer().GetAngleZ())
	myBed = self.PlaceAtMe(Bedroll01)
	self.MoveTo(self, 0.0, 0.0, -9.0)
	pCreateTime = GetCurrentGameTime()
	RegisterForUpdate(1)
endEvent

Event OnActivate(ObjectReference akActionRef)
       
    int iButton = _DE_CampTent_Placed_ACT_Menu.Show()
  
    ;What do you want to do?
    ;1: Pack Tent 2: Cancel
  
    if iButton == 0
        Tent_Placed_Destroy()
    elseif iButton == 1
        ;do nothing
    endif
endEvent

Event OnUpdate()
	if pSnowTentCreated == false
		if Weather.GetCurrentWeather() == "[Weather < (0004D7FB)>]" || Weather.GetCurrentWeather() == "[Weather < (000C8221)>]"	;It's snowing right now!
			;Add "snowy" tent on top of current one
			SnowTent = self.PlaceAtMe(NorTentSmallSnow)
			SnowTent.MoveTo(SnowTent, 0.0, 0.0, 0.1)
			pSnowTentCreated = true
		elseif _DE_CurrentTemp.GetValueInt() <= -10								;Player is in snowy terrain
			if GetCurrentGameTime() - pCreateTime > 0.0416					;Wait 1 Hour
				;Add "snowy" tent on top of current one
				SnowTent = self.PlaceAtMe(NorTentSmallSnow)
				SnowTent.MoveTo(SnowTent, 0.0, 0.0, 0.1)
				pSnowTentCreated = true
			endif
		endif
	endif
endEvent

function Tent_Placed_Destroy()
	if _DE_Setting_Tent.GetValueInt() == 1
		;Drives degrading the tent's durability
		if self.GetBaseObject() == _DE_CampTent_Placed_ACT_10
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_9)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_9
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_8)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_8
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_7)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_7
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_6)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_6
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_5)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_5
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_4)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_4
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_3)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_3
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_2)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_2
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_1)
		elseif self.GetBaseObject() == _DE_CampTent_Placed_ACT_1
			_DE_Backpack_MISC_Error_Tent_FallApart.Show()
			Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_0)
		endif	
		
		UnregisterForUpdate()
		SnowTent.disable()
		SnowTent.Delete()
		self.disable(true)
		self.Delete()
		myBed.disable(true)
		myBed.Delete()
			
	else
		Game.GetPlayer().AddItem(_DE_CampTentHide_MISC_10)
		UnregisterForUpdate()
		SnowTent.disable()
		SnowTent.Delete()
		self.disable(true)
		self.Delete()
		myBed.disable(true)
		myBed.Delete()
	endif
endfunction